package com.steerinfo.util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;
import com.hnshituo.basic.spring.web.interceptor.SessionTimeOutException;
import com.hnshituo.basic.util.DataEncoder;

public class JsonSessionInterceptor extends HandlerInterceptorAdapter {
	/**
	 * 在业务处理器处理请求之前被调用 如果返回false 从当前的拦截器往回执行所有拦截器的afterCompletion(),再退出拦截器链
	 * 如果返回true 执行下一个拦截器,直到所有的拦截器都执行完毕 再执行被拦截的Controller 然后进入拦截器链,
	 * 从最后一个拦截器往回执行所有的postHandle() 接着再从最后一个拦截器往回执行所有的afterCompletion()
	 */
	@Override
	public boolean preHandle(HttpServletRequest request,
			HttpServletResponse response, Object handler) throws Exception {
		
		String userId = (String) request.getSession().getAttribute("userId");
		
		String requestUri = request.getRequestURI();
		String BasePath=requestUri.substring(requestUri.lastIndexOf("/")+1);
		String clinetIp=request.getRemoteAddr(); //客户端ip
		String IpEncode = DataEncoder.shaEncode(clinetIp); //密文用来跟config.proprity文件中的信息匹配
		/*
		Properties ps = PropertiesUtils.getProperties();
		Set<Map.Entry<Object, Object>> entrySet = ps.entrySet();//返回的属性键值对实体
        for (Map.Entry<Object, Object> entry : entrySet) {
        	if(!IpEncode.equals(IpEncode)){
        		throw new Exception("当前客户端未配置计量点信息");
        	}
            //system.out.println(entry.getKey() + "=" + entry.getValue());
        }
        //*/
		
		//监听移动端，WinForm端不考虑session过期
		if((BasePath.contains("App") || BasePath.contains("Web")) && userId==null){
			throw new SessionTimeOutException();
		}
		return true;
	}

	/**
	 * 在业务处理器处理请求执行完成后,生成视图之前执行的动作 可在modelAndView中加入数据，比如当前时间
	 */
	@Override
	public void postHandle(HttpServletRequest request,
			HttpServletResponse response, Object handler,
			ModelAndView modelAndView) throws Exception {
	}

	/**
	 * 在DispatcherServlet完全处理完请求后被调用,可用于清理资源等
	 * 
	 * 当有拦截器抛出异常时,会从当前拦截器往回执行所有的拦截器的afterCompletion()
	 */
	@Override
	public void afterCompletion(HttpServletRequest request,
			HttpServletResponse response, Object handler, Exception ex)
			throws Exception {
	}

}

